<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_OperationTime ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_OperationTime extends AbstractStructArrayBase
{
    /**
     * The OperationTime
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_OperationTime[]
     */
    public $OperationTime;
    /**
     * Constructor method for ArrayOfJP_OperationTime
     * @uses ArrayOfJP_OperationTime::setOperationTime()
     * @param \StructType\JP_OperationTime[] $operationTime
     */
    public function __construct(array $operationTime = array())
    {
        $this
            ->setOperationTime($operationTime);
    }
    /**
     * Get OperationTime value
     * @return \StructType\JP_OperationTime[]|null
     */
    public function getOperationTime()
    {
        return $this->OperationTime;
    }
    /**
     * Set OperationTime value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_OperationTime[] $operationTime
     * @return \ArrayType\ArrayOfJP_OperationTime
     */
    public function setOperationTime(array $operationTime = array())
    {
        foreach ($operationTime as $arrayOfJP_OperationTimeOperationTimeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_OperationTimeOperationTimeItem instanceof \StructType\JP_OperationTime) {
                throw new \InvalidArgumentException(sprintf('The OperationTime property can only contain items of \StructType\JP_OperationTime, "%s" given', is_object($arrayOfJP_OperationTimeOperationTimeItem) ? get_class($arrayOfJP_OperationTimeOperationTimeItem) : gettype($arrayOfJP_OperationTimeOperationTimeItem)), __LINE__);
            }
        }
        $this->OperationTime = $operationTime;
        return $this;
    }
    /**
     * Add item to OperationTime value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_OperationTime $item
     * @return \ArrayType\ArrayOfJP_OperationTime
     */
    public function addToOperationTime(\StructType\JP_OperationTime $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_OperationTime) {
            throw new \InvalidArgumentException(sprintf('The OperationTime property can only contain items of \StructType\JP_OperationTime, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->OperationTime[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_OperationTime|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_OperationTime|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_OperationTime|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_OperationTime|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_OperationTime|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OperationTime
     */
    public function getAttributeName()
    {
        return 'OperationTime';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_OperationTime
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
